function [ filtered ] = DepthFilter( depth, minPixels, maxPixels )
%DepthFilter Averages the depth in numPixels x numPixels pixels ignoring the 0s in
%the depth
    offset=floor((maxPixels-1)/2) ;
    filtered = ones(size(depth))*0 ;
    for i = (1+offset):(size(depth,1)-offset)
        for j = (1+offset):(size(depth,2)-offset)
            pixels = floor((minPixels-1)/2) ;
            while ( pixels < floor((maxPixels-1)/2) && filtered(i,j) == 0 )
                depthSubset = depth(i-pixels:i+pixels,j-pixels:j+pixels) ;
                nonZIndices = find(depthSubset ~= 0) ;
                if ( ~isempty(nonZIndices) )
                    filtered(i,j) = mean(depthSubset(nonZIndices)) ;
                end
                pixels = pixels + 1 ;
            end
        end
    end
end


% function [ filtered ] = DepthFilter( depth, numPixels )
% %DepthFilter Averages the depth in numPixels x numPixels pixels ignoring the 0s in
% %the depth
%     offset=floor((numPixels-1)/2) ;
%     filtered = ones(size(depth))*0 ;
%     for i = (1+offset):(size(depth,1)-offset)
%         for j = (1+offset):(size(depth,2)-offset)
%             depthSubset = depth(i-offset:i+offset,j-offset:j+offset) ;
%             nonZIndices = find(depthSubset ~= 0) ;
%             if ( ~isempty(nonZIndices) )
%                 filtered(i,j) = mean(depthSubset(nonZIndices)) ;
%             end
%         end
%     end
% end
% 
