close all
clc

% Example script to acquire images from the Kinect camera in Matlab
% -------------------------------------------------------------------------
% Kinect class uses a slightly modified Microsoft Kinect SDK application
% DepthWithColor-D3 and SharedMemDLL.dll to stream images from the Kinect camera
% to this script. This script initializes the shared memory and then launches 
% DepthWithColor-D3D.exe. DepthWithColor-D3D connects to the % shared memory 
% and starts streaming RGB and depth images to it. 
% This is preferable to using the KinectForWindowsExample.m because
% DepthWithColor-D3D aligns the RGB and Depth images.
% close all ;
numFrames = 10 ;
h1 = figure(10) ;
h2 = figure(11) ;

% Initialize Kinect and Shared Memory
kinectCam = Kinect() ;
for i=1:numFrames
    % Get Image
    [rgb,depth] = kinectCam.GetImage() ;
    if ( i == 1 )
        tstart= tic ;
        % Initialize figures
        figure(h1) ; h1imagesc = imagesc(depth) ;
        caxis([400 1000]) ;
        figure(h2) ; h2image = image(rgb) ;
    else
        % Just update figures
        set(h1imagesc,'CData',depth) ;
        set(h2image,'CData',rgb) ;
    end
    % Update figures. On some computers, it can't run at 30 fps unless you
    % comment out this line
    drawnow
end
% Shutdown Kinect and Shared Memory
kinectCam.ShutDown() ;

% Measure Frame Rate
fpsAgg = i/toc(tstart)



