// SharedMemClient.cpp : Defines the entry point for the console application.
// Launch SharedMem.cpp first and then launch SharedMemClient.cpp

#include "stdafx.h"
#include <windows.h>
#include <stdio.h>
#include <conio.h>
#include <tchar.h>
#include "..\SharedMem\privilege.h"
#include "..\SharedMem\SharedMem.h"

// #pragma comment(lib, "user32.lib")

//TCHAR szName[]=TEXT("Global\\MyFileMappingObject");
//TCHAR mutexName[]=TEXT("Global\\MyFileMutex") ;

TCHAR szName[]=TEXT(FILE_MAP_NAME);
TCHAR mutexName[]=TEXT(MUTEX_NAME) ;


char pBufTemp[BUF_SIZE] ; // Must be module level or causes unhandled exception - probably caused by stack too small

int _tmain()
{

   HANDLE hMapFile;
   LPCTSTR pBuf;
   char *pCurrBuf ;
   HANDLE ghMutex; 
   DWORD dwWaitResult; 
   int rdPtr, numElements ;


   // Create Mutex
	ghMutex = CreateMutex( 
        NULL,              // default security attributes
        FALSE,             // initially not owned
        mutexName);             // unnamed mutex

    if (ghMutex == NULL) 
    {
		_tprintf(TEXT("CreateMutex error: %d\n"),GetLastError());
		return 1;
    }

	Privilege(TEXT("SeLockMemoryPrivilege"), TRUE);


	 hMapFile = OpenFileMapping(
                   FILE_MAP_ALL_ACCESS,   // read/write access
                   FALSE,                 // do not inherit the name
                   szName);               // name of mapping object

   if (hMapFile == NULL)
   {
      _tprintf(TEXT("Could not open file mapping object (%d).\n"),
             GetLastError());
      return 1;
   }
	long largePageMin = GetLargePageMinimum();
	long smSize = (ALL_BUFS_SIZE/largePageMin + 1)*largePageMin ;
   pBuf = (LPTSTR) MapViewOfFile(hMapFile, // handle to map object
               FILE_MAP_ALL_ACCESS,  // read/write permission
               0,
               0,
               smSize);

   if (pBuf == NULL)
   {
      _tprintf(TEXT("Could not map view of file (%d).\n"),
             GetLastError());

      CloseHandle(hMapFile);

      return 1;
   }
   printf("hMapFile %x\n",hMapFile) ;
   printf("ghMutex %x\n",ghMutex) ;
   printf("pBuf %x\n",pBuf) ;

   // Read messages to Shared Memory
   for (int i=0;i<10;i++)
   {
	   numElements = 0 ;
	   while (numElements == 0)
	   {
			dwWaitResult = WaitForSingleObject( 
				ghMutex,    // handle to mutex
				INFINITE);  // no time-out interval
			numElements = MM_VALUE(pBuf,NUM_ELEMENTS) ;
			if (numElements)
			{
				rdPtr = MM_VALUE(pBuf,RD_PTR) ;
				pCurrBuf = (char *)pBuf +HEADER_SIZE+rdPtr*BUF_SIZE ;
				CopyMemory((PVOID)pBufTemp, (PVOID)pCurrBuf, BUF_SIZE);
				MM_VALUE(pBuf,RD_PTR) = (rdPtr + 1) % NUM_BUFS ;
				MM_VALUE(pBuf,NUM_ELEMENTS) = numElements - 1 ;
			}
			if (!ReleaseMutex(ghMutex))
			{
				_tprintf(TEXT("ReleaseMutex error: %d\n"),GetLastError());
				return 1;
			}
			Sleep(100) ;
	   }
	   printf("Received \n%s\n",pCurrBuf) ;
   }

	Privilege(TEXT("SeLockMemoryPrivilege"), FALSE);

   UnmapViewOfFile(pBuf);

   CloseHandle(hMapFile);

   return 0;
}
